function reg_enc = mq_encoder_init

%     This file is part of mq_codec.
% 
%     mq_codec is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     any later version.
% 
%     mq_codec is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with mq_codec.  If not, see <http://www.gnu.org/licenses/>.
%
% MQ encoder_init routine
% 
% Syntax
%     reg_enc = mq_encoder_init
%     
% Outputs
%     reg_enc ~ state-registers for the coder (initializes)
%     
% Note
%     Implemented from p. 478 of [1]
% 
% [1] David S. Taubman and Michael W. Marcellin, JPEG2000, Image Compression 
%     Fundamentals, Standards and Practice, Kluwer Academic Publishers, 2002
%
% see also mq_encoder, mq_encoder_end
%
% Xavier Alameda Pineda (xavi.alameda at gmail.com) v1.0 - 20/May/2009
% Image and Video Processing Group, Technical University of Catalonia

reg_enc = struct;

% % reg_encister Initialitzation
% % ------------------------

% reg_encister values

reg_enc.C =     uint32(0);  % Lower-bound interval
reg_enc.A = uint16(32768);  % Upper-bound interval 0x8000
reg_enc.t =     uint8(12);  % Cound-down variablexs
reg_enc.T =      uint8(0);  % Temporary byte reg_encister
reg_enc.L =     int32(-1);  % Byte-transfered counter

reg_enc.byte_stream = uint8([]);