function reg_enc = mq_put_byte(reg_enc)

%     This file is part of mq_codec.
% 
%     mq_codec is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     any later version.
% 
%     mq_codec is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with mq_codec.  If not, see <http://www.gnu.org/licenses/>.
%
% MQ put_byte routine
% 
% Syntax
%     reg_enc = mq_put_byte(reg_enc)
%     
% Inputs
%     reg_enc ~ state-registers for the coder
%     
% Outputs
%     reg_enc ~ state-registers for the coder
%     
% Note
%     Implemented from p. 479 of [1]
% 
% [1] David S. Taubman and Michael W. Marcellin, JPEG2000, Image Compression 
%     Fundamentals, Standards and Practice, Kluwer Academic Publishers, 2002
%
% see also mq_transfer_byte, mq_encoder
%
% Xavier Alameda Pineda (xavi.alameda at gmail.com) v1.0 - 20/May/2009
% Image and Video Processing Group, Technical University of Catalonia

if reg_enc.L >= 0
    reg_enc.byte_stream = [reg_enc.byte_stream reg_enc.T];
%    fprintf('MQ_ENC: byte_written = %s\n',dec2bin(reg_enc.T));
end
reg_enc.L = reg_enc.L+1;