function reg_dec = mq_renormalize_once(reg_dec)

%     This file is part of mq_codec.
% 
%     mq_codec is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     any later version.
% 
%     mq_codec is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with mq_codec.  If not, see <http://www.gnu.org/licenses/>.
%
% MQ renormalize_once routine
% 
% Syntax
%     reg_dec = mq_renormalize_once(reg_dec)
%     
% Inputs
%     reg_dec ~ state-registers for the decoder
%     
% Outputs
%     reg_dec ~ state-registers for the decoder
%     
% Note
%     Implemented from p. 479 of [1]
% 
% [1] David S. Taubman and Michael W. Marcellin, JPEG2000, Image Compression 
%     Fundamentals, Standards and Practice, Kluwer Academic Publishers, 2002
%
% see also mq_decoder, mq_fill_lsbs
%
% Xavier Alameda Pineda (xavi.alameda at gmail.com) v1.0 - 20/May/2009
% Image and Video Processing Group, Technical University of Catalonia

if reg_dec.t == 0
    reg_dec = mq_fill_lsbs(reg_dec);
end
reg_dec.A = 2*reg_dec.A;
reg_dec.C = 2*reg_dec.C;
reg_dec.t = reg_dec.t-1;